var O = Object.defineProperty;
var B = (r, t, e) => t in r ? O(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e;
var y = (r, t, e) => (B(r, typeof t != "symbol" ? t + "" : t, e), e);
const c = globalThis.process ?? { env: {}, versions: {} }, E = { ...c == null ? void 0 : c.env }, L = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...c == null ? void 0 : c.versions
}, je = (c == null ? void 0 : c.platform) ?? "unknown", Ae = (c == null ? void 0 : c.arch) ?? "unknown";
class m extends Error {
  constructor(e, s) {
    super(e);
    y(this, "code");
    y(this, "stack");
    y(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack, "code" in s && typeof s.code == "string" && (this.code = s.code));
  }
}
const M = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], H = "browserstack-client", N = "3.5.0", W = "BrowserStack APIs client library for node.js", K = "module", V = "./dist/browserstack-client.umd.cjs", X = {
  "browserstack-local": "./dist/node/browserstack-local.cjs",
  "browserstack-app-automate": "./dist/node/browserstack-app-automate.cjs"
}, Q = "./dist/browserstack-client.js", J = "./dist/types/index.d.ts", Y = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Z = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs",
  "generate:java": "npx @openapitools/openapi-generator-cli generate --generator-key java",
  "generate:kotlin": "npx @openapitools/openapi-generator-cli generate --generator-key kotlin",
  "generate:csharp": "npx @openapitools/openapi-generator-cli generate --generator-key csharp",
  "generate:ruby": "npx @openapitools/openapi-generator-cli generate --generator-key ruby"
}, ee = "Shirish Kamath", te = "MIT", se = [
  "dist/**/*",
  "*.d.ts"
], ae = {
  node: ">=18.0.0"
}, re = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.19",
  "@typescript-eslint/eslint-plugin": "^7.0.1",
  "@typescript-eslint/parser": "^7.0.1",
  "@vitest/coverage-v8": "1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.7",
  typedoc: "^0.25.9",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.9",
  typescript: "^5.3.3",
  vite: "^5.1.4",
  "vite-plugin-dts": "^3.7.3",
  vitepress: "^1.0.0-rc.44",
  vitest: "1.2.1"
}, ne = {
  fflate: "^0.8.2",
  "openapi-fetch": "^0.9.2",
  "signal-exit": "^4.1.0"
}, ie = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, oe = "https://shirish87.github.io/browserstack-client/", pe = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, ue = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], d = {
  name: H,
  version: N,
  description: W,
  type: K,
  main: V,
  bin: X,
  module: Q,
  types: J,
  exports: Y,
  scripts: Z,
  author: ee,
  license: te,
  files: se,
  engines: ae,
  devDependencies: re,
  dependencies: ne,
  repository: ie,
  homepage: oe,
  bugs: pe,
  keywords: ue
}, le = [d == null ? void 0 : d.name, d == null ? void 0 : d.version].filter(Boolean).join("/"), de = ["node", L.node].filter(Boolean).join("/"), ce = [le, de].filter(Boolean).join(" "), me = {
  name: d == null ? void 0 : d.name,
  version: d == null ? void 0 : d.version,
  userAgent: ce
}, fe = {
  "Content-Type": "application/json"
}, he = /\{[^{}]+\}/g;
function T(r) {
  let {
    baseUrl: t = "",
    fetch: e = globalThis.fetch,
    querySerializer: s,
    bodySerializer: a,
    headers: n,
    ...o
  } = { ...r };
  t.endsWith("/") && (t = t.substring(0, t.length - 1)), n = C(fe, n);
  const p = [];
  async function f(u, i) {
    let {
      fetch: k = e,
      headers: U,
      params: A = {},
      parseAs: I = "json",
      querySerializer: R,
      bodySerializer: _ = a ?? be,
      ...F
    } = i || {}, S = typeof s == "function" ? s : G(s);
    R && (S = typeof R == "function" ? R : G({
      ...typeof s == "object" ? s : {},
      ...R
    }));
    const b = {
      redirect: "follow",
      ...o,
      ...F,
      headers: C(n, U, A.header)
    };
    b.body && (b.body = _(b.body)), b.body instanceof FormData && b.headers.delete("Content-Type");
    let w = new Request(
      ye(u, { baseUrl: t, params: A, querySerializer: S }),
      b
    );
    const x = {
      baseUrl: t,
      fetch: k,
      parseAs: I,
      querySerializer: S,
      bodySerializer: _
    };
    for (const h of p)
      if (h && typeof h == "object" && typeof h.onRequest == "function") {
        w.schemaPath = u, w.params = A;
        const g = await h.onRequest(w, x);
        if (g) {
          if (!(g instanceof Request))
            throw new Error(
              "Middleware must return new Request() when modifying the request"
            );
          w = g;
        }
      }
    let l = await k(w);
    for (let h = p.length - 1; h >= 0; h--) {
      const g = p[h];
      if (g && typeof g == "object" && typeof g.onResponse == "function") {
        const P = await g.onResponse(l, x);
        if (P) {
          if (!(P instanceof Response))
            throw new Error(
              "Middleware must return new Response() when modifying the response"
            );
          l = P;
        }
      }
    }
    if (l.status === 204 || l.headers.get("Content-Length") === "0")
      return l.ok ? { data: {}, response: l } : { error: {}, response: l };
    if (l.ok)
      return I === "stream" ? { data: l.body, response: l } : { data: await l[I](), response: l };
    let D = await l.text();
    try {
      D = JSON.parse(D);
    } catch {
    }
    return { error: D, response: l };
  }
  return {
    /** Call a GET endpoint */
    async GET(u, i) {
      return f(u, { ...i, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(u, i) {
      return f(u, { ...i, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(u, i) {
      return f(u, { ...i, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(u, i) {
      return f(u, { ...i, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(u, i) {
      return f(u, { ...i, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(u, i) {
      return f(u, { ...i, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(u, i) {
      return f(u, { ...i, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(u, i) {
      return f(u, { ...i, method: "TRACE" });
    },
    /** Register middleware */
    use(...u) {
      for (const i of u)
        if (i) {
          if (typeof i != "object" || !("onRequest" in i || "onResponse" in i))
            throw new Error(
              "Middleware must be an object with one of `onRequest()` or `onResponse()`"
            );
          p.push(i);
        }
    },
    /** Unregister middleware */
    eject(...u) {
      for (const i of u) {
        const k = p.indexOf(i);
        k !== -1 && p.splice(k, 1);
      }
    }
  };
}
function j(r, t, e) {
  if (t == null)
    return "";
  if (typeof t == "object")
    throw new Error(
      "Deeply-nested arrays/objects aren’t supported. Provide your own `querySerializer()` to handle these."
    );
  return `${r}=${(e == null ? void 0 : e.allowReserved) === !0 ? t : encodeURIComponent(t)}`;
}
function $(r, t, e) {
  if (!t || typeof t != "object")
    return "";
  const s = [], a = {
    simple: ",",
    label: ".",
    matrix: ";"
  }[e.style] || "&";
  if (e.style !== "deepObject" && e.explode === !1) {
    for (const p in t)
      s.push(
        p,
        e.allowReserved === !0 ? t[p] : encodeURIComponent(t[p])
      );
    const o = s.join(",");
    switch (e.style) {
      case "form":
        return `${r}=${o}`;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${r}=${o}`;
      default:
        return o;
    }
  }
  for (const o in t) {
    const p = e.style === "deepObject" ? `${r}[${o}]` : o;
    s.push(j(p, t[o], e));
  }
  const n = s.join(a);
  return e.style === "label" || e.style === "matrix" ? `${a}${n}` : n;
}
function z(r, t, e) {
  if (!Array.isArray(t))
    return "";
  if (e.explode === !1) {
    const n = { form: ",", spaceDelimited: "%20", pipeDelimited: "|" }[e.style] || ",", o = (e.allowReserved === !0 ? t : t.map((p) => encodeURIComponent(p))).join(n);
    switch (e.style) {
      case "simple":
        return o;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${r}=${o}`;
      case "spaceDelimited":
      case "pipeDelimited":
      default:
        return `${r}=${o}`;
    }
  }
  const s = { simple: ",", label: ".", matrix: ";" }[e.style] || "&", a = [];
  for (const n of t)
    e.style === "simple" || e.style === "label" ? a.push(e.allowReserved === !0 ? n : encodeURIComponent(n)) : a.push(j(r, n, e));
  return e.style === "label" || e.style === "matrix" ? `${s}${a.join(s)}` : a.join(s);
}
function G(r) {
  return function(e) {
    const s = [];
    if (e && typeof e == "object")
      for (const a in e) {
        const n = e[a];
        if (n != null) {
          if (Array.isArray(n)) {
            s.push(
              z(a, n, {
                style: "form",
                explode: !0,
                ...r == null ? void 0 : r.array,
                allowReserved: (r == null ? void 0 : r.allowReserved) || !1
              })
            );
            continue;
          }
          if (typeof n == "object") {
            s.push(
              $(a, n, {
                style: "deepObject",
                explode: !0,
                ...r == null ? void 0 : r.object,
                allowReserved: (r == null ? void 0 : r.allowReserved) || !1
              })
            );
            continue;
          }
          s.push(j(a, n, r));
        }
      }
    return s.join("&");
  };
}
function ge(r, t) {
  let e = r;
  for (const s of r.match(he) ?? []) {
    let a = s.substring(1, s.length - 1), n = !1, o = "simple";
    if (a.endsWith("*") && (n = !0, a = a.substring(0, a.length - 1)), a.startsWith(".") ? (o = "label", a = a.substring(1)) : a.startsWith(";") && (o = "matrix", a = a.substring(1)), !t || t[a] === void 0 || t[a] === null)
      continue;
    const p = t[a];
    if (Array.isArray(p)) {
      e = e.replace(
        s,
        z(a, p, { style: o, explode: n })
      );
      continue;
    }
    if (typeof p == "object") {
      e = e.replace(
        s,
        $(a, p, { style: o, explode: n })
      );
      continue;
    }
    if (o === "matrix") {
      e = e.replace(
        s,
        `;${j(a, p)}`
      );
      continue;
    }
    e = e.replace(s, o === "label" ? `.${p}` : p);
  }
  return e;
}
function be(r) {
  return JSON.stringify(r);
}
function ye(r, t) {
  var a;
  let e = `${t.baseUrl}${r}`;
  (a = t.params) != null && a.path && (e = ge(e, t.params.path));
  let s = t.querySerializer(t.params.query ?? {});
  return s.startsWith("?") && (s = s.substring(1)), s && (e += `?${s}`), e;
}
function C(...r) {
  const t = new Headers();
  for (const e of r) {
    if (!e || typeof e != "object")
      continue;
    const s = e instanceof Headers ? e.entries() : Object.entries(e);
    for (const [a, n] of s)
      if (n === null)
        t.delete(a);
      else if (Array.isArray(n))
        for (const o of n)
          t.append(a, o);
      else
        n !== void 0 && t.set(a, n);
  }
  return t;
}
const [{ variables: v }, { variables: q }] = M ?? [], ke = `${v.scheme.default}://${v.host.default}${v.basePath ? v.basePath.default : ""}`, we = `${q.scheme.default}://${q.host.default}${q.basePath ? q.basePath.default : ""}`;
class Re {
  constructor(t) {
    y(this, "sdk");
    y(this, "sdkCloud");
    const e = t.username ?? E.BROWSERSTACK_USERNAME;
    if (t.usernameOptional !== !0 && (typeof e != "string" || !e.trim().length))
      throw new m("Missing options.username");
    const s = t.key ?? E.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new m("Missing options.key");
    const a = {
      ...t,
      baseUrl: t.baseUrl ?? ke,
      headers: {
        ...t.headers,
        Authorization: e ? `Basic ${btoa(`${e}:${s}`)}` : void 0,
        "User-Agent": me.userAgent
      }
    };
    this.sdk = T(a), this.sdkCloud = T({
      ...a,
      baseUrl: we
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(t, ...e) {
    const s = await this.sdk.GET(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(t, ...e) {
    const s = await this.sdk.POST(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(t, ...e) {
    const s = await this.sdkCloud.GET(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(t, ...e) {
    const s = await this.sdkCloud.POST(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(t, ...e) {
    const s = await this.sdk.PUT(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(t, ...e) {
    const s = await this.sdk.PATCH(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(t, ...e) {
    const s = await this.sdk.DELETE(t, ...e);
    if (s.error || !s.data)
      throw new m("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
}
class Ie extends Re {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(t) {
    return this.makeGetRequest("/app-automate/plan.json", t);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(t) {
    return this.makeGetRequest("/app-automate/devices.json", t);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(t) {
    return this.makeGetRequest("/app-automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(t, e, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: t
        }
      },
      body: e
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new m(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (a) => {
          const n = new FormData();
          return n.append("file", a.file, e.filename), n;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: (a) => {
          const n = new FormData();
          return n.append("file", a.file, e.filename), n;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(t, e, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param data - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const a = new FormData();
        return a.append("file", s.file, t.filename), s.custom_id && a.append("custom_id", s.custom_id), a;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...e,
        params: {
          path: {
            mediaId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param data - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(t, e) {
    return this.makePostRequest("/app-automate/upload", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const a = new FormData();
        return "file" in s ? a.append("file", s.file, t.filename) : a.append("url", s.url), s.custom_id && a.append("custom_id", s.custom_id), a;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(t) {
    return this.makeGetRequest("/app-automate/recent_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(t) {
    return this.makeGetRequest("/app-automate/recent_group_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(t, e) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param data - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(t, e, s) {
    return this.makePostRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: e,
        bodySerializer: (a) => {
          const n = new FormData();
          return "file" in a ? n.append("file", a.file, e.filename) : n.append("url", a.url), a.custom_id && n.append("custom_id", a.custom_id), n;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(t, e) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      e
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(t, e, s) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    ).then((a) => "app" in a ? a.app : a.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(t, e, s) {
    return this.makeDeleteRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param data - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(t, e) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const a = new FormData();
        return "file" in s ? a.append("file", s.file, t.filename) : a.append("url", s.url), s.custom_id && a.append("custom_id", s.custom_id), a;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(t, e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(t, e) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param data - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(t, e) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...e,
      body: t,
      bodySerializer: (s) => {
        const a = new FormData();
        return "file" in s ? a.append("file", s.file, t.filename) : a.append("url", s.url), s.custom_id && a.append("custom_id", s.custom_id), a;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(t, e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(t, e) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads a Detox Android app or app client to the App Automate service.
   *
   * @param type - The type of the upload, either "app" or "app-client".
   * @param data - The data of the upload, including the app file and filename.
   * @param options - Optional API fetch options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadDetoxAndroidApp(t, e, s) {
    return this.makePostRequest(
      t ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: e,
        bodySerializer: (a) => {
          const n = new FormData();
          return "file" in a ? n.append("file", a.file, e.filename) : n.append("url", a.url), a.custom_id && n.append("custom_id", a.custom_id), n;
        }
      }
    );
  }
}
var ve = /* @__PURE__ */ ((r) => (r.android = "android", r.ios = "ios", r))(ve || {});
export {
  Re as A,
  m as B,
  ve as F,
  Ie as a,
  je as b,
  Ae as c,
  E as e
};
